@echo off

rem	GAMS Scenario Interface SubProgram -- figure.bat
rem	Thomas F. Rutherford
rem	December, 2000

rem	Syntax:  
rem
rem		FIGURE id item sc1 [sc2 sc3 sc4 sc5 sc6]
rem	or
rem		FIGURE id scenario item1 [item2 item3 item4 item5 item6]
rem	or
rem		FIGURE id item1.sc1 [item2.sc2 item3.sc3 item4.sc4 item5.sc5 item6.sc6]
rem	where
rem
rem	id		is the plot identifier (GAMS code is stored in output\id.gms)
rem
rem	items		are model output
rem
rem	scenarios	are previously solved cases.

rem	Define whether Excel output is generated by default with the
rem	following statement  (xls=yes or xls=no):

set xls=no


if "%1"=="" goto syntax
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

rem	Read the identifier:

set id=%1
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

rem	Check the operating mode:

if exist output\items\%1 goto item
if exist scenarios\%1    goto scenario
goto multiplot

rem	Plot one item across multiple scenarios:

:item
set item=%1
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"==""	goto noscenarios

echo	$setglobal ident %id%		>output\%id%.gms
echo	$setglobal item %item%		>>output\%id%.gms

if not exist scenarios\%1 goto noscenario
if not exist output\%1.sol goto nosolution
echo	$setglobal sc1   %1		>>output\%id%.gms
echo	$setglobal item1 %item%		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift


if "%1"=="" goto generate
if not exist scenarios\%1 goto noscenario
if not exist output\%1.sol goto nosolution
echo	$setglobal sc2   %1		>>output\%id%.gms
echo	$setglobal item2 %item%		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist scenarios\%1 goto noscenario
if not exist output\%1.sol goto nosolution
echo	$setglobal sc3   %1		>>output\%id%.gms
echo	$setglobal item3 %item%		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist scenarios\%1 goto noscenario
if not exist output\%1.sol goto nosolution
echo	$setglobal sc4   %1		>>output\%id%.gms
echo	$setglobal item4 %item%		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist scenarios\%1 goto noscenario
if not exist output\%1.sol goto nosolution
echo	$setglobal sc5   %1		>>output\%id%.gms
echo	$setglobal item5 %item%		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist scenarios\%1 goto noscenario
if not exist output\%1.sol goto nosolution
echo	$setglobal sc6   %1		>>output\%id%.gms
echo	$setglobal item6 %item%		>>output\%id%.gms
goto generate

:noscenarios
echo.
echo	Error:  no scenarios specified for plot of %item%
echo.
pause
goto syntax
goto end

:noscenario
echo.
echo	Error:	plot scenario %1 not found.
echo.
echo	Must be one of the following:
echo.
dir /b scenarios
echo.
goto end

:nosolution
echo.
echo	Error:	plot scenario %1 has not been solved.
echo.
goto end

rem	Plot several items for a single scenario:

:scenario
set sc=%1
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"==""	goto noitems

echo	$setglobal ident %id%		>output\%id%.gms
echo	$setglobal scenario %sc%	>>output\%id%.gms

if not exist output\items\%1 goto noitem
echo	$setglobal sc1   %sc%		>>output\%id%.gms
echo	$setglobal item1 %1		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist output\items\%1 goto noitem
echo	$setglobal sc2   %sc%		>>output\%id%.gms
echo	$setglobal item2 %2		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist output\items\%1 goto noitem
echo	$setglobal sc3   %sc%		>>output\%id%.gms
echo	$setglobal item3 %1		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist output\items\%1 goto noitem
echo	$setglobal sc4   %sc%		>>output\%id%.gms
echo	$setglobal item4 %1		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist output\items\%1 goto noitem
echo	$setglobal sc5   %sc%		>>output\%id%.gms
echo	$setglobal item5 %1		>>output\%id%.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

if "%1"=="" goto generate
if not exist output\items\%1 goto noitem
echo	$setglobal sc6   %sc%		>>output\%id%.gms
echo	$setglobal item6 %1		>>output\%id%.gms
goto generate

:noitems
echo.
echo	Error:  no items specified for plot.
echo.
pause
goto syntax
goto end


:noitem
echo.
echo	Error:	plot item %1 not found.
echo.
echo	Must be one of the following:
echo.
dir /b output\items
echo.
goto end


rem	Plot a collection of item.scenario paris:

:multiplot
echo	set plots (*,*) /	>output\parse.gms
:loop
if "%1"=="" goto rungams
echo	%1	>>output\parse.gms
shift
if "%1"=="/xls" set xls=yes
if "%1"=="/xls" shift

goto loop
:rungams
echo	/; >>output\parse.gms
echo	alias (*,u,uu); file kdef /output\%id%.gms/; put kdef; scalar	n /1/;	>>output\parse.gms
echo	loop(plots(u,uu), put '$setglobal item',n:0:0,' ',u.tl/; put '$setglobal sc',n:0:0,' ',uu.tl/;	n = n + 1); >>output\parse.gms
call gams output\parse o=output\parse.lst suppress=0 lo=0 lf=output\parse.log
echo	$setglobal multiplot yes	>>output\%id%.gms	
echo	$setglobal ident %id%		>>output\%id%.gms
if errorlevel 1 goto parseerror
goto generate

:parseerror
echo.
echo	An error occured parsing plot list input.  Here is listing file parse.lst:
echo.
pause
type output\parse.lst
goto end


rem	Generate the figure using GAMS:

:generate
if %xls%==yes	echo	$setglobal xls yes	>>output\%id%.gms
echo	$libinclude figure			>>output\%id%.gms
if     exist inclib\nul call gams output\%id%.gms o=output\%id%.lst relpath=1 ldir=.\inclib
if not exist inclib\nul call gams output\%id%.gms o=output\%id%.lst

goto end

:syntax
echo.
echo	Syntax:  
echo.
echo		FIGURE id item sc1 [sc2 sc3 sc4 sc5 sc6]
echo	or
echo		FIGURE id scenario item1 [item2 item3 item4 item5 item6]
echo	or
echo		FIGURE id item1.sc1 [item2.sc2 item3.sc3 item4.sc4 item5.sc5 item6.sc6]
echo	where
echo.
echo	id		is the plot identifier (GAMS code is stored in output\id.gms)
echo.
echo	items are one of:
echo.
dir /b output\items
echo.
echo	scenarios are one of:
echo.
dir /b scenarios
echo.
:end
