*	GAMS Scenario Interface Subprogram -- figure.gms
*	Thomas F. Rutherford
*	December, 2000

*	Define the scenario and item sets first so that we order things sequentially:

set plots(*,*) /
$if exist output\%sc1%.sol %item1%.%sc1%
$if exist output\%sc2%.sol %item2%.%sc2%
$if exist output\%sc3%.sol %item3%.%sc3%
$if exist output\%sc4%.sol %item4%.%sc4%
$if exist output\%sc5%.sol %item5%.%sc5%
$if exist output\%sc6%.sol %item6%.%sc6%
/;
set item(*), scenario(*); alias (u,uu,*);
item(u) = yes$sum(plots(u,uu), 1);
scenario(u)   = yes$sum(plots(uu,u), 1);

*	Blank invocation permit set declarations:

$batinclude output\%sc1%.sol 

*	Read the data, one series at a time:

$onempty
parameter d1(*,*) /
$if exist output\%sc1%.sol $batinclude output\%sc1%.sol %item1%
/;
parameter d2(*,*) /
$if exist output\%sc2%.sol $batinclude output\%sc2%.sol %item2%
/;
parameter d3(*,*) /
$if exist output\%sc3%.sol $batinclude output\%sc3%.sol %item3%
/;
parameter d4(*,*) /
$if exist output\%sc4%.sol $batinclude output\%sc4%.sol %item4%
/;
parameter d5(*,*) /
$if exist output\%sc5%.sol $batinclude output\%sc5%.sol %item5%
/;
parameter d6(*,*) /
$if exist output\%sc6%.sol $batinclude output\%sc6%.sol %item6%
/;

parameter data(*,*,*);
$if exist output\%sc1%.sol data("%sc1%",u,"%item1%") = d1("%sc1%",u);
$if exist output\%sc2%.sol data("%sc2%",u,"%item2%") = d2("%sc2%",u);
$if exist output\%sc3%.sol data("%sc3%",u,"%item3%") = d3("%sc3%",u);
$if exist output\%sc4%.sol data("%sc4%",u,"%item4%") = d4("%sc4%",u);
$if exist output\%sc5%.sol data("%sc5%",u,"%item5%") = d5("%sc5%",u);
$if exist output\%sc6%.sol data("%sc6%",u,"%item6%") = d6("%sc6%",u);

$if setglobal scenario  parameter %ident%(*,*)  "%title% -- %scenario%" ; 
$if setglobal item      parameter %ident%(*,*)  "%title% -- %item%" ; 
$if setglobal multiplot parameter %ident%(*,*,*)  "%title%" ; 

$if setglobal scenario  %ident%(u,item) = data("%scenario%",u,item);
$if setglobal item      %ident%(u,scenario) = data(scenario,u,"%item%");
$if setglobal multiplot %ident%(u,item,scenario)$plots(item,scenario) = data(scenario,u,item);

$setglobal series
$if setglobal multiplot $setglobal series plots

$libinclude plot %ident%
display %ident%;

*	Generate an Excel file with the figure data:

$if not setglobal xls $setglobal xls=no
$if setglobal multiplot $setglobal xls=no
$if %xls%==yes $libinclude xlwrite %ident% output\%ident%.xls