$if not setglobal debug $offlisting offinclude

$hidden   Updated 6/01 (tfr)

$version 86

$hidden   gams2txt.gms    Data export to GAMS-readable format (no declaration)
$hidden   
$hidden   $...include gams2txt [item1 item2 ...]
$hidden   
$hidden   (i) Works for parameters, variables, equations and sets
$hidden   
$hidden   (ii) First invocation must be outside of a loop or if block. 
$hidden   
$hidden   (iii) Use a blank invocation (without an id) to initialize.
$hidden   
$hidden   (iv)  Explanatory text are written as the "data" for SETs.
$hidden   
$hidden   (v) Values of EPS are written as zero on the output file.
$hidden   
$hidden   (vi) Global environment variable "prefix" can specify a 
$hidden   prefix to the output label.  For example:
$hidden   
$hidden         scalar x /1/;
$hidden         $setglobal prefix "'x'"
$hidden         file xfile /xfile/; put xfile;
$hidden         $libinclude gams2txt x
$hidden 
$hidden   produces
$hidden   
$hidden         x  1.00000000000000E+00
$hidden   
$hidden   The prefix can be loaded dynamically using the text label
$hidden   for a loop index, as in:
$hidden
$hidden         set i /a,b/, sc/sc1,sc2/;
$hidden         parameter x(i) /a 1, b 2/;
$hidden         $setglobal prefix "sc.tl,'.'"
$hidden         file xfile /xfile/; put xfile;
$hidden         $libinclude gams2txt 
$hidden         loop(sc,
$hidden         $libinclude gams2txt x
$hidden         );
$hidden 
$hidden   This produces:
$hidden   
$hidden         SC1.A  1.00000000000000E+00
$hidden         SC1.B  2.00000000000000E+00
$hidden         SC2.A  1.00000000000000E+00
$hidden         SC2.B  2.00000000000000E+00
$hidden   
$hidden   (viii) Global environment variable "zeros" specifies whether to
$hidden   write zeros to the output file:
$hidden
$hidden         set i /i1,i2/, j /j1,j2/, k /k1,k2,k3/;
$hidden         table   x(i,j,k)
$hidden                         k1      k2      k3
$hidden         i1.j1           1               
$hidden         i2.j2                   2;
$hidden         
$hidden   is written (under defaults):
$hidden 
$hidden         I1.J1.K1  1.00000000000000E+00
$hidden         I2.J2.K2  2.00000000000000E+00
$hidden 
$hidden   When "$setglobal zeros yes", x is written:
$hidden   
$hidden   I1.J1.K1  1.00000000000000E+00
$hidden   I1.J1.K2  0.00000000000000E+00
$hidden   I2.J2.K1  0.00000000000000E+00
$hidden   I2.J2.K2  2.00000000000000E+00
$hidden   
$hidden   Note in this example that rows which are entirely zero
$hidden   (I1.J2, I2.J1), and columns which are entirely zero (K3)
$hidden   are not written.) 
$hidden   

*       Skip compilation is there is a pre-existing program error:

$if not errorfree $exit

$if declared gms2txt1 $goto start

*       Declare temporary variables used for data transfer.


alias(u__1,u__2,u__3,u__4, u__5,u__6,u__7,u__8,u__9,u__10,*);
alias(uu__1,uu__2,uu__3,uu__4, uu__5,uu__6,uu__7,uu__8,uu__9,uu__10,*);
set gms2txt1,gms2txt2,gms2txt3,gms2txt4,gms2txt5,gms2txt6,gms2txt7,gms2txt8,gms2txt9,gms2txt10;

*       Avoid stray names warnings by some dummy assignments:

gms2txt1("gams2txt") = yes;
gms2txt2("gams2txt","gams2txt") = yes;
gms2txt3("gams2txt","gams2txt","gams2txt") = yes;
gms2txt4("gams2txt","gams2txt","gams2txt","gams2txt") = yes;
gms2txt5("gams2txt","gams2txt","gams2txt","gams2txt","gams2txt") = yes;
gms2txt6("gams2txt","gams2txt","gams2txt","gams2txt","gams2txt","gams2txt") = yes;
gms2txt7("gams2txt","gams2txt","gams2txt","gams2txt","gams2txt","gams2txt",
         "gams2txt") = yes;
gms2txt8("gams2txt","gams2txt","gams2txt","gams2txt","gams2txt","gams2txt",
         "gams2txt","gams2txt") = yes;
gms2txt9("gams2txt","gams2txt","gams2txt","gams2txt","gams2txt","gams2txt",
         "gams2txt","gams2txt","gams2txt") = yes;
gms2txt10("gams2txt","gams2txt","gams2txt","gams2txt","gams2txt","gams2txt",
         "gams2txt","gams2txt","gams2txt","gams2txt") = yes;

option clear=gms2txt1; option clear=gms2txt2; option clear=gms2txt3; 
option clear=gms2txt4; option clear=gms2txt5; option clear=gms2txt6; 
option clear=gms2txt7; option clear=gms2txt8; option clear=gms2txt9; 
option clear=gms2txt10;

$if errorfree $goto noerror
$onlisting

*       An error has occured during the initial invocation of
*       gams2txt. There are two reasons than an error may have
*       been generated here:

*       (i) The first invocation of gams2txt is inside an if or loop.  
*       The simple solution for this problem is to use initialize with
*       "$libinclude gams2txt" before entering the loop or if.

*       (ii) User program has used one of the gams2txt reserved names, 
*       u__n, uu__n and gams2txtn for n = 0,1,2,...,10.

$abort 'Error on initial $libinclude gams2txt.'

$label noerror

*       Blank invocation -- nothing to do:

$if %1a == a $exit

$if errorfree $goto start
$onlisting

*       An error has occured on the initial put.

*       The calling program must include "file id /name/; put id;" 
*       before calling GAMS2PRM or GAMS2TXT.

$error Error in gams2txt: Put file must be open before invocation.
$exit

*       Return to this point with each item to be written:

$label start

*       End of items to write:

$if %1a == a $exit

*       See that the item is declared and defined:

$if declared %1    $goto declared
$error Error in gams2txt: identfier %1 is undeclared.
$exit

$label declared
$if defined %1     $goto defined
$error Error in gams2txt: identfier %1 is undefined.
$exit

$label defined
$if settype %1 $goto declare
$if partype %1 $goto declare
$if vartype %1 $goto declare
$if equtype %1 $goto declare
$error Error in gams2txt: identfier %1 is not a set, parameter, variable or equation.
$exit

*       Set up temporary sets for processing:

$label declare
$if dimension 0 %1 $goto scalar 
$if dimension 1 %1 $set r 'u__1' set s 'gms2txt1' 
$if dimension 2 %1 $set r 'u__1,u__2' set s 'gms2txt2' set rr 'u__1' set ss 'gms2txt1' set rrr 'uu__1' set col 'u__2' 
$if dimension 3 %1 $set r 'u__1,u__2,u__3' set s 'gms2txt3' set rr 'u__1,u__2' set ss 'gms2txt2' set rrr 'uu__1,uu__2' set col 'u__3' 
$if dimension 4 %1 $set r 'u__1,u__2,u__3,u__4' set s 'gms2txt4' set rr 'u__1,u__2,u__3' set ss 'gms2txt3'  set rrr 'uu__1,uu__2,uu__3' set col 'u__4' 
$if dimension 5 %1 $set r 'u__1,u__2,u__3,u__4,u__5' set s 'gms2txt5' set rr 'u__1,u__2,u__3,u__4' set ss 'gms2txt4' set rrr 'uu__1,uu__2,uu__3,uu__4' set col 'u__5' 
$if dimension 6 %1 $set r 'u__1,u__2,u__3,u__4,u__5,u__6' set s 'gms2txt6' set rr 'u__1,u__2,u__3,u__4,u__5' set ss 'gms2txt5'  set rrr 'uu__1,uu__2,uu__3,uu__4,uu__5' set col 'u__6' 
$if dimension 7 %1 $set r 'u__1,u__2,u__3,u__4,u__5,u__6,u__7' set s 'gms2txt7' set rr 'u__1,u__2,u__3,u__4,u__5,u__6' set ss 'gms2txt6'  set rrr 'uu__1,uu__2,uu__3,uu__4,uu__5,uu__6' set col 'u__7' 
$if dimension 8 %1 $set r 'u__1,u__2,u__3,u__4,u__5,u__6,u__7,u__8' set s 'gms2txt8' set rr 'u__1,u__2,u__3,u__4,u__5,u__6,u__7' set ss 'gms2txt7'  set rrr 'uu__1,uu__2,uu__3,uu__4,uu__5,uu__6,uu__7' set col 'u__8' 
$if dimension 9 %1 $set r 'u__1,u__2,u__3,u__4,u__5,u__6,u__7,u__8,u__9' set s 'gms2txt9' set rr 'u__1,u__2,u__3,u__4,u__5,u__6,u__7,u__8' set ss 'gms2txt8'  set rrr 'uu__1,uu__2,uu__3,uu__4,uu__5,uu__6,uu__7,uu__8' set col 'u__9' 
$if dimension 10 %1 $set r 'u__1,u__2,u__3,u__4,u__5,u__6,u__7,u__8,u__9,u__10'set s 'gms2txt10'set rr 'u__1,u__2,u__3,u__4,u__5,u__6,u__7,u__8,u__9'set ss 'gms2txt9'set rrr 'uu__1,uu__2,uu__3,uu__4,uu__5,uu__6,uu__7,uu__8,uu__9'set col 'u__10' 
*	Declared for %1: r=%r% s=%s% ss=%ss% 
$onuni

*       Default: unquoted labels

$set tfopt 3
$set delim " "

*       User can request comma-delimited output format:

$if setglobal commadelim $set tfopt "4" set delim ","
$if setglobal commadelim $log Comma delimited output.
$if "%commadelim%"=="no" $set tfopt "3" set delim " "

*       New option: quoted labels

$if setglobal quotes $set tfopt 5

file.lw=0; file.nr=2; file.nw=22; file.nd=13; file.tf=%tfopt%;

*       Specify the set of elements which are to be written.
*       This only skips values which are identically zero.  It
*       does not skip EPS (which is written as 0) and it does
*       not skip NA (which is written as NA).

%s%(%r%)$%1(%r%) = yes;

$if settype %1 $goto header

*       Here is where we reinsert zero rows if they are requested.
*       This is primarily included for spreadsheet-export of data,
*       where we might want to automatically fill with zeros any 
*       columns which have a non-zero element:

*	zeros=%zeros%

$if not setglobal zeros $setglobal zeros no
*	$if "%zeros%" == "yes" %ss%(%rr%) = yes$sum(%col%$%s%(%rr%,%col%), 1);
$if "%zeros%" == "yes" %ss%(%rr%) = yes$sum(%col%$%s%(%rr%,%col%), 1);
$if "%zeros%" == "yes" %s%(%ss%,%col%) = yes$sum((%rrr%)$%1(%rrr%,%col%), 1);

$label header

$setargs args

$if "%gams2prm%"=="yes" $goto write
$if not setglobal timestamp $setglobal timestamp yes
$if not %timestamp%==yes $goto write

put "*=>gams2txt %args%"/;
put "* Called from %system.incparent% -- line %system.line%"/;
put "* %system.date% %system.time%"/;

$label write
$if settype %1 $goto writeset

$if setglobal indexed put '$if "%','1"=="" $goto %1'/;
$if setglobal indexed put '$if not "%','1"=="%1" $goto _%1'/;
$if setglobal indexed put '$label %1'/;
loop(%s%, 
$if setglobal prefix put %prefix%; 
put %s%.te(%s%) '%delim%' %1(%s%)/;
);
$if setglobal indexed put '$if not "%','1"=="" $exit'/;
$if setglobal indexed put '$label _%1'/;
$goto cleanup

$label writeset
$if setglobal indexed put '$if "%','1"=="" $goto %1'/;
$if setglobal indexed put '$if not "%','1"=="%1" $goto _%1'/;
$if setglobal indexed put '$label %1'/;
loop(%s%(%r%), 
$if setglobal prefix put %prefix%; 
file.tf=%tfopt%; put %s%.te(%s%); file.tf=1; 
put '%delim%' '"'%1.te(%r%)'"'/;
);
$if setglobal indexed put '$if not "%','1"=="" $exit'/;
$if setglobal indexed put '$label _%1'/;
$goto cleanup

$label cleanup
file.tf=3;
$offuni
option clear=%s%;
$if "%zeros%" == "yes" option clear=%ss%;

*       Permit multiple items to be written on a single call:

$shift
$goto start


$label scalar
file.nr =  2;
file.nw = 22;
file.nd = 13;
file.tf =  3;

$if setglobal indexed put '$if "%','1"=="" $goto %1'/;
$if setglobal indexed put '$if not "%','1"=="%1" $goto _%1'/;
$if setglobal indexed put '$label %1'/;
$if not setglobal prefix put %1/;
$if     setglobal prefix put %prefix%,%1/;
$if setglobal indexed put '$if not "%','1"=="" $exit'/;
$if setglobal indexed put '$label _%1'/;

*       Permit multiple items to be written on a single call:

$shift
$goto start
