$if not setglobal debug $offlisting offinclude

$setargs args

$version 86

$hidden   GAMS2ZIP: Data export to ZIP archive (GAMS-readable format)

$hidden   gams2zip.gms    Data export to ZIP archive format (no declaration)
   
$hidden   Requires compatible ZIP in the GAMS directory or on the PATH.

$hidden   ZIP and UNZIP are found at http://www.cdrom.com/pub/infozip/Info-Zip.html

$hidden   $...include gams2zip [ [-m] archive item1 [-m] [-n name1] [item2 [-m] [-n name2]  ...] ]


*       Switches and details:

*       Blank invocation generates declarations.

*       -m      Means merge rather than replace.  If this switch appears specified prior to the 
*               archive name, then all items are merged.  Otherwise, the switch applies only to the 
*               current item.  (Default mode: replace)

*       -n      Indicates that the next field is to be the archive name for the
*               current item.


$hidden   Created 1/98 (tfr)

$hidden   Retrieval:

$hidden   $...include zip2gams archive [item1 [-n name] [item2 ...]

*       Skip compilation is there is a pre-existing program error:

$if not errorfree $exit

$if not declared u__1 $libinclude gams2txt

$if not errorfree $exit

$set filename '%gams.scrdir%gams2zip.scr'
$if not declared gams2zip_f file gams2zip_f / %filename% /; gams2zip_f.pw=255;
$if not declared gams2zip_i set gams2zip_i(*,*) Index of ZIP file contents;
$if not setglobal debug $goto chkerror

$if not declared zipcon file zipcon/con/;

$label chkerror
$if errorfree $goto begin


$onlisting

*       An error has occured during initialization in gams2zip.
*       There are two reasons than an error may have been generated here:

*       (i) The first invocation of gams2zip is inside an if or loop.  
*       The simple solution for this problem is to use initialize with
*       "$libinclude gams2zip" before entering the loop or if.

*       (ii) User program has used one of the gams2zip reserved names, 
*       gams2zip_f or gams2zip_i.

$abort 'Error on initial $libinclude gams2zip.'

$label begin

*       Skip out on blank invocation:

$if "%1"=="" $exit

*       See if we are to merge everything:

$set mergeall no
$if "%1"=="-m" $set mergeall yes
$if "%1"=="-M" $set mergeall yes
$if "%1"=="-m" $shift
$if "%1"=="-M" $shift

*       Read the archive name as the first argument:

$set archive %1
$set newarchive yes
$if exist %archive%     $set newarchive no
$if exist %archive%.zip $set newarchive no

*       Permit the mergeall flag to appear on either side of the
*       archive name:

$if "%1"=="-m" $set mergeall yes
$if "%1"=="-M" $set mergeall yes
$if "%1"=="-m" $shift
$if "%1"=="-M" $shift


*------------------------------------------------------------------------------
*       Run from here for each item on the list:

$label start

$shift


$if "%1"=="" $exit

$if "%1"=="-m" $abort "Syntax Error in GAMS2ZIP: -m flag not expected in this location: %args%"
$if "%1"=="-M" $abort "Syntax error in GAMS2ZIP: -M flag not expected in this location: %args%"

$if not declared %1 $abort "Syntax Error in GAMS2ZIP: item %1 is not declared (%args%)!"
$if not defined  %1 $abort "Syntax Error in GAMS2ZIP: item %1 is not defined (%args%)!"

$set item %1
$set name %1
$set merge %mergeall%

$label checkflag

$if "%2"=="-m" $goto mergeflag
$if "%2"=="-M" $goto mergeflag
$goto checkname

$label mergeflag
$set merge yes
$shift
$goto checkflag

$label checkname
$if "%2"=="-n" $goto nameflag
$if "%2"=="-N" $goto nameflag
$goto putit


$label nameflag

*       -N must be followed by a name

$if not "%3"=="" $goto nameok

$log "Invalid syntax for gams2zip item %item%."
$log "-N must be followed by new name."
$abort "Syntax error in call gams2zip for arguments %args%"


$label nameok
$set name %3
$shift
$shift
$goto checkflag

$label putit

*       Default behavior: replace the archive contents:

gams2zip_f.ap = 0;

*       Skip this if we are in replace mode:

$if %merge%==no $goto timestamp

*       Forget about merge with a new archive:

$if %newarchive%==yes $goto timestamp

*       This is a merge operation -- need to unzip the file first and then
*       set up the put to append:


$if setglobal debug putclose zipcon, "Newarchive = %newarchive%"/;
$if setglobal debug execute "dir %gams.scrdir%";
$if setglobal debug putclose zipcon, "unzip -o -q -C %archive% %name% -d %gams.scrdir%"/;
$if setglobal debug execute "pause";
execute "%gams.sdir%unzip -o -q -C %archive% %name% -d %gams.scrdir%";

$if setglobal debug execute "dir %gams.scrdir%";
$if setglobal debug execute "pause";

$libinclude rename "%gams.scrdir%" "%name%" GAMS2ZIP.SCR 
gams2zip_f.ap = 1;
put gams2zip_f, '$onmulti'/;

*       Put a timestamp on the file if one is requested:

$label timestamp

$if not setglobal timestamp $setglobal timestamp yes
$if not %timestamp%==yes $goto write

put gams2zip_f;
put "*=>gams2zip %args%"/;
put "* Current item: %item%"/;
put "* Called from %system.incparent%, line %system.line%"/;
put "* %system.date% %system.time%"/;

$label write

$set ts %timestamp%
$setglobal timestamp no

put gams2zip_f;
$libinclude gams2txt %item% 
putclose;

$setglobal timestamp %ts%

*       Rename the temporary file to be the name of the parameter.
*       We then zip with a "move" so that these files do not hang around.

$if setglobal debug putclose zipcon, 'rename "%gams.scrdir%" GAMS2ZIP.SCR "%name%"'/;
$if setglobal debug execute "dir %gams.scrdir%";
$if setglobal debug execute "pause";

$libinclude rename "%gams.scrdir%" GAMS2ZIP.SCR "%name%"

$if setglobal debug execute "dir %gams.scrdir%";
$if setglobal debug putclose zipcon, "zip %archive% -9 -q -m -j %gams.scrdir%%name%"/;
$if setglobal debug execute "pause";

gams2zip_i("%archive%","%name%") = yes;
execute "%gams.sdir%zip %archive% -9 -q -m -j %gams.scrdir%%name%";

*       Add this item to the unpack file:

$if exist %archive%.zip     $call "%gams.sdir%unzip -o -q -C %archive% UNPACK.SCR -d %gams.scrdir%";
$if not exist %archive%.zip $call "if exist %gams.scrdir%UNPACK.SCR del %gams.scrdir%UNPACK.SCR"
$escape =
$echo "$if not set %name% $libinclude zip2gams %=1 %name%" >>%gams.scrdir%UNPACK.SCR
$echo "$set %name%"  >>%gams.scrdir%UNPACK.SCR
$call "%gams.sdir%zip %archive% -9 -q -m -j %gams.scrdir%UNPACK.SCR";

*       Update the index file:

$goto start
