$if not setglobal debug $offlisting offinclude

*----------------------------------------------------------------------------- 
* GAMS Source Code (resides in the ldir directory)
*----------------------------------------------------------------------------- 


*----------------------------------------------------------------------------- 
*       Fold all environment variables to lower case:
*----------------------------------------------------------------------------- 

$if "%gp_key%" == "NO"          $setglobal gp_key no 

$if "%gp_yzeroax%"=="YES"       $setglobal gp_yzeroax yes
$if "%gp_xzeroaxis%"=="YES"     $setglobal gp_xzeroaxis yes
$if "%gp_zeroaxis%"=="YES"      $setglobal gp_zeroaxis yes      
$if "%gp_border%"=="YES"        $setglobal gp_border yes                
$if "%gp_tics%"=="YES"          $setglobal gp_tics yes          
$if "%gp_label%"=="YES"         $setglobal gp_label yes         
$if "%gp_grid%"=="YES"          $setglobal gp_grid yes

$if "%gp_yzeroax%"=="NO"        $setglobal gp_yzeroax no
$if "%gp_xzeroaxis%"=="NO"      $setglobal gp_xzeroaxis no
$if "%gp_zeroaxis%"=="NO"       $setglobal gp_zeroaxis no
$if "%gp_border%"=="NO"         $setglobal gp_border no
$if "%gp_tics%"=="NO"           $setglobal gp_tics no
$if "%gp_label%"=="NO"          $setglobal gp_label no
$if "%gp_grid%"=="NO"           $setglobal gp_grid no

$if "%gp_yzeroax%"=="Yes"       $setglobal gp_yzeroax yes
$if "%gp_xzeroaxis%"=="Yes"     $setglobal gp_xzeroaxis yes
$if "%gp_zeroaxis%"=="Yes"      $setglobal gp_zeroaxis yes      
$if "%gp_border%"=="Yes"        $setglobal gp_border yes                
$if "%gp_tics%"=="Yes"          $setglobal gp_tics yes          
$if "%gp_label%"=="Yes"         $setglobal gp_label yes         
$if "%gp_grid%"=="Yes"          $setglobal gp_grid yes

$if "%gp_yzeroax%"=="No"        $setglobal gp_yzeroax no
$if "%gp_xzeroaxis%"=="No"      $setglobal gp_xzeroaxis no
$if "%gp_zeroaxis%"=="No"       $setglobal gp_zeroaxis no
$if "%gp_border%"=="No"         $setglobal gp_border no
$if "%gp_tics%"=="No"           $setglobal gp_tics no
$if "%gp_label%"=="No"          $setglobal gp_label no
$if "%gp_grid%"=="No"           $setglobal gp_grid no


$if "%gp_term%"=="GIF"      $setglobal gp_term gif
$if "%gp_term%"=="WINDOWS"  $setglobal gp_term windows
$if "%gp_term%"=="SVGA"     $setglobal gp_term svga

*----------------------------------------------------------------------------- 
*       Declarations:
*----------------------------------------------------------------------------- 

$if not declared gp__1          alias(gp__1,gp__2,*);
$if not declared gp_row         set gp_row(*), gp_col(*);
$if not declared gp_r           parameter gp_r(*), gp_c(*);
$if not declared gp_rr          alias (gp_rr,gp_row);
$if not declared gp_inp         file gp_inp /gnuplot.inp/; 
$if not declared gp_data        file gp_data /gnuplot.dat/; 
$if not declared gp_na          scalar gp_na /na/; 
$if not declared gp_count       scalar gp_count, gp_counter;
$if not setglobal gp_style         $setglobal gp_style lines
$if not setglobal gp_xtics         $setglobal gp_xtics no

*  Include tics on the X axis if labels are provided:

$if setglobal gp_xl  $setglobal gp_xtics yes

*       If no arguments, this is solely for intialization:

$if a%1 == a $exit

$if declared %1                 $goto declared

$error GNUPLOT: Identfier %1 is not declared.
$exit

$label declared
$if defined %1     $goto defined
$error GNUPLOT: identfier %1 is not defined.
$exit

$label defined
$if dimension 2 %1 $goto start
$error GNUPLOT: identfier %1 is not two-dimensional.
$exit

$label start

*       Permit user to specify an alternative value for NA:

$if setglobal gp_na gp_na = %gp_na%;

*       Avoid an invocation of gnuplot with a spurious initialization:

*       Extract row and column labels:

$onuni
gp_row(gp__1)$sum(gp__2, %1(gp__1,gp__2)) = yes;
gp_col(gp__2)$sum(gp__1, %1(gp__1,gp__2)) = yes;

$if not setglobal gp_row $setglobal gp_row 
$if not setglobal gp_col $setglobal gp_col 

$if not "%gp_row%"=="" gp_row(gp__1) = no;
$if not "%gp_col%"=="" gp_col(gp__2) = no;
$if not "%gp_row%"=="" gp_row(%gp_row%) = yes;
$if not "%gp_col%"=="" gp_col(%gp_col%) = yes;

gp_count = 0;
loop(gp_row, 
$if not setglobal gp_x gp_r(gp_row) = gp_count; 
$if     setglobal gp_x gp_r(gp_row) = %gp_x%(gp_row);
  gp_count = gp_count + 1;
);

gp_count = 0;
loop(gp_col, 
$if not setglobal gp_y gp_c(gp_col) = gp_count; 
$if     setglobal gp_y gp_c(gp_col) = %gp_y%(gp_col);
  gp_count = gp_count + 1;
);



put gp_inp;
file.lw = 0;
file.nr = 0;
file.nd = 0;
file.nw = 6;

$if not setglobal gp_output  $setglobal gp_output
$if not setglobal gp_term    $setglobal gp_term
$if not setglobal gp_options $setglobal gp_options

$if not setglobal gp_suffix $setglobal gp_suffix bin
$if "%gp_term%" == "gif"    $setglobal gp_suffix gif
$if "%gp_output%"==""       $setglobal gp_output %1.%gp_suffix%

$if "%gp_term%" == "gif"     $goto gif_term
$if "%gp_term%" == "windows" $goto start_file
$if "%gp_term%" == "svga"    $goto start_file
$if "%gp_term%" == ""        $goto start_file

*       The user has specified a terminal format:

put gp_inp "set term %gp_term%"/;
put gp_inp "set output '%gp_output%'"/;

$goto start_file

$label gif_term
$if "%gp_version%" == "3.5" $abort "Error: gp_term=gif not available with GNUPLOT Version 3.5."
$if %system.filesys% == DOS $abort "Error: gp_term=gif only runs in 32 bit (Windows 95 or NT)."
put gp_inp "set term gif"/;
put gp_inp "set output '%gp_output%'"/;
$goto start_file

$label start_file

*       Erase the file name after each item is generated:

$setglobal gp_output 

put 'set title "',%1.ts,'"'/;

$if not setglobal gp_x  put 'set xrange [1:',card(gp_row),']'/;

file.nd = 3;
file.nw = 12;
$if setglobal gp_x put 'set xrange [',(smin(gp_row,%gp_x%(gp_row))),':',(smax(gp_row,%gp_x%(gp_row))),']'/;

$if not setglobal gp_xl $goto options

put 'set xtics (';
file.nd = 3;
file.nw = 12;
gp_count = 0;
gp_counter = 0;
loop(gp_row,
  gp_count=gp_count+1; 
  if (%gp_xl%(gp_row), 
    gp_counter = gp_counter + 1;
    if (gp_counter gt 1, put ',';);
$if not setglobal gp_x  put '\'/' "',%gp_xl%.te(gp_row),'" ',gp_count;
$if     setglobal gp_x  put '\'/' "',%gp_xl%.te(gp_row),'" ',%gp_x%(gp_row);
  );
); 
put ')'/;

*       Pass through any user-specified options:

$label options
$if setglobal gp_xrange   put 'set xrange %gp_xrange%'/;
$if setglobal gp_yrange   put 'set yrange %gp_yrange%'/;
$if setglobal gp_boxwid   put 'set boxwidth %gp_boxwid%'/;
$if setglobal gp_size     put 'set size %gp_size%'/;
$if %gp_grid% == yes      put 'set grid'/;
$if %gp_grid% == no       put 'set nogrid'/;
$if %gp_label% == yes     put 'set label'/;
$if %gp_label% == no      put 'set nolabel'/;
$if %gp_tics% == yes      put 'set tics'/;
$if %gp_tics% == no       put 'set notics'/;
$if %gp_xtics% == no      put 'set noxtics'/;
$if %gp_border% == yes    put 'set border'/;
$if %gp_border% == no     put 'set noborder'/;
$if %gp_zeroaxis% == yes  put 'set zeroaxis'/;
$if %gp_zeroaxis% == no   put 'set nozeroaxis'/;
$if %gp_xzeroaxis% == yes put 'set xzeroaxis'/;
$if %gp_xzeroaxis% == no  put 'set noxzeroaxis'/;
$if %gp_yzeroax% == yes   put 'set yzeroaxis'/;
$if %gp_yzeroax% == no    put 'set noyzeroaxis'/;

*       We set the key location here.  If we are
*       running under DOS, the "set key outside" command
*       does not run.  In this case, take the default location.
*       Otherwise, place the key on the outside (right).

$if %system.filesys% == DOS  $goto xlabel
$if not setglobal gp_key put 'set key outside'/;
$if not setglobal gp_key $goto xlabel
$if "%gp_key%" == "no"     put 'set nokey'/;
$if not "%gp_key%" == "no" put 'set key    %gp_key%'/;

$label xlabel
$if setglobal gp_title  put 'set title  "%gp_title%"'/;
$if setglobal gp_xlabel put 'set xlabel "%gp_xlabel%"'/;
$if setglobal gp_ylabel put 'set ylabel "%gp_ylabel%"'/;
$if setglobal gp_style  put 'set data style %gp_style%'/;

$label startplt

*       Permit user-override of up to 10 GNUPLOT features:

$if setglobal gp_opt0  put '%gp_opt0%'/;
$if setglobal gp_opt1  put '%gp_opt1%'/;
$if setglobal gp_opt2  put '%gp_opt2%'/;
$if setglobal gp_opt3  put '%gp_opt3%'/;
$if setglobal gp_opt4  put '%gp_opt4%'/;
$if setglobal gp_opt5  put '%gp_opt5%'/;
$if setglobal gp_opt6  put '%gp_opt6%'/;
$if setglobal gp_opt7  put '%gp_opt7%'/;
$if setglobal gp_opt8  put '%gp_opt8%'/;
$if setglobal gp_opt9  put '%gp_opt9%'/;


file.nd = 0;
file.nw = 6;

$if not "%gp_contour%"=="yes" $goto chart

put 'splot "gnuplot.dat" using 1:2:3 notitle with lines'/;
putclose;

gp_data.nw = 16;
gp_data.nd = 8;
gp_data.nr = 2;
put gp_data;

loop(gp_row, 
  loop(gp_col, 
    put gp_data, gp_r(gp_row), gp_c(gp_col), %1(gp_row,gp_col)/; 
  ); 
  put /;
);

$goto runplot


$label chart
gp_count=1;
put 'plot '; 
loop(gp_col, 
  if (gp_count gt 1, put ',';);
  file.nw = 0

*       GNUPLOT changed the file format between versions 3.5 and 3.6,
*       so the DOS-based machines will use version 3.5 and the
*       W95- and NT-based use version 3.6 which is compiled in 32 bit:

$if "%gp_version%" == "3.5" $goto ver3_5fmt
$if %system.filesys% == DOS $goto ver3_5fmt
  put  '\'/' "gnuplot.dat" index ',(gp_count-1):0:0,
        ' using 1:2 "%lf%lf" title "',gp_col.tl,'"';
$goto setboxes

$label ver3_5fmt
  if (gp_count gt 1,
    put  '\'/' "gnuplot.dat" using "%=16f%*',
        ((gp_count-1)*16),'[^\n]%=16f" title "',gp_col.tl,'"';
  else
    put  '\'/' "gnuplot.dat" using "%=16f%=16f" title "',gp_col.tl,'"';
  );

$label setboxes

$if setglobal gp_boxes put ' with boxes';
  file.nw = 6;
  gp_count = gp_count + 1;
); put /;

$if "%gp_term%"=="windows" put '!if exist gnuplot.ini del gnuplot.ini >nul'/;
putclose;

gp_data.nw = 16;
gp_data.nd = 8;
gp_data.nr = 2;

$if "%gp_version%" == "3.5"  $goto ver3_5data
$if  %system.filesys% == DOS $goto ver3_5data

loop(gp_col,
  gp_count=0;
  loop(gp_row,
    gp_count=gp_count+1;
$if not setglobal gp_x put gp_data, gp_count;
$if     setglobal gp_x put gp_data, %gp_x%(gp_row);
    if (%1(gp_row,gp_col) eq gp_na,
      put gp_data, '          ';
    else
      put gp_data, %1(gp_row,gp_col);
    );
    put /;
  );
  put //;
);
$goto runplot

$label ver3_5data

gp_count=0;
loop(gp_row,
  gp_count=gp_count+1;

$if not setglobal gp_x put gp_data, gp_count;
$if     setglobal gp_x put gp_data, %gp_x%(gp_row);

  loop(gp_col, 
    if (%1(gp_row,gp_col) eq gp_na,
      put gp_data, '          ';
    else
      put gp_data, %1(gp_row,gp_col);
    );
  );
  put /;
);
$goto runplot

$label runplot
putclose;

*       We are done with the row and column sets.  Clean them
*       out so that they can be used a second time:

gp_row(gp__1) = no;
gp_col(gp__2) = no;

$offuni

*       Run gnuplot:

$if     "%gp_term%"=="gif" execute '%gams.sdir%gnugif gnuplot.inp';
$if     "%gp_term%"=="gif" $exit

$if "%gp_term%"=="windows" execute 'copy gnuplot.inp gnuplot.ini >nul';

$if "%gp_version%" == "3.5" $goto DOS
$if %system.filesys% == DOS $goto DOS

$if not "%gp_term%"=="windows" execute '%gams.sdir%gp36 gnuplot.inp';
$if     "%gp_term%"=="windows" execute '%gams.sdir%wgnupl32';
$exit

$label DOS
$if not "%gp_term%"=="windows" execute '%gams.sdir%gnuplot gnuplot.inp';
$if     "%gp_term%"=="windows" execute '%gams.sdir%wgnuplot';
$exit


