$if not setglobal debug $offlisting offinclude

$ontext

         SSDUMP: GAMS Spreadsheet Creation and Data Export Utility

                     (an interface to SSLINK.EXE)

Usage:

$LIBINCLUDE SSDUMP ident[.suffix] ssfile [range]

            N.B.  Data transfer occurs at execution time.

This routine is different from SSEXPORT in the following ways:

(1) The target worksheet can be created "from scratch" in 
    Lotus, Excel or Quattro formats.

(2) All data and labels are written into the worksheet, ordered
    by the GAMS symbol table.  There are no facilities for 
    matching data to labels within the spreadsheet.

    N.B. The ordering of row and column labels written to the
    spreadsheet is effectively random and cannot be controlled
    (it follows the GAMS program symbol table).  If a particular
    ordering is desired, do a SSDUMP first, then rearrange the
    rows/columns within the spreadsheet and subsequently use
    SSEXPORT to move data in accordance with the spreadsheet
    labels.

(3) A single cell target range (e.g. "B1..B1") produces a dynamic
    range which expands to accomdate all the data.  

$offtext

$if setglobal ss_system $goto countargs
$setglobal ss_system 'operating'
$echo %system.gstring%     >sslink.log
$echo SSLINK Activity Log >>sslink.log
$label countargs

$hidden         Begin by checking that the parameter exists:

$if a%4 == a $goto begin
$error  SSDUMP invoked with 4 arguments? 1=%1 2=%2 3=%3 4=%4  
$error  Syntax requires at most 3 arguments.
$log    SSDUMP invoked with 4 arguments? 1=%1 2=%2 3=%3 4=%4  
$log    Syntax requires at most 3 arguments.
$abort

$label begin
$if declared %1    $goto declared
$error SSDUMP identfier %1 is not declared.
$log   SSDUMP identfier %1 is not declared.
$abort

$label declared
$if defined %1     $goto defined
$error SSDUMP identfier %1 is not defined.
$log   SSDUMP identfier %1 is not defined.
$abort

$label defined
$call '=%gams.sdir%sslink parse %2 >parse.gms'
$include parse.gms
$call del parse.gms >nul

$setlocal format  ''
$setlocal range   '%3'
$goto start

$hidden         At this point, we have the file format and range specified

$label start
$setlocal data   '%1'
$setlocal ssfile '%2'
$if a%range% == a  $setlocal range 'a1..a1'

$if not exist %ssfile% $goto new_file
$log  --- Saving existing file %ssfile% to %basename%.bak 
$echo --- Saving existing file %ssfile% to %basename%.bak >>sslink.log
$call 'copy %ssfile% %basename%.bak >nul';

$label new_file
$if a%format% == a $goto old_file

$log --- Dumping "%data%" into new spreadsheet file "%ssfile%"  
execute 'copy %gams.ldir%template.%format% %ssfile% >nul';
$goto open_tmp

$label old_file
$if exist %ssfile% $goto existing
$if %extension% == WK1 $goto defaultfmt
$if %extension% == WQ2 $goto defaultfmt
$if %extension% == XLS $goto defaultfmt
$onlisting
$error  SSDUMP cannot infer worksheet format from file extension "%extension%".
$log    SSDUMP cannot infer worksheet format from file extension "%extension%".
$abort

$label defaultfmt
$log --- Dumping "%data%" into "%ssfile%" with format %extension%
$setlocal format '%extension%'
execute 'copy %gams.ldir%template.%format% %ssfile% >nul';
$goto open_tmp

$label existing
$log --- Dumping "%data%" into existing spreadsheet file "%ssfile%"  
$goto open_tmp

$label open_tmp
$set newfile '%gams.scrdir%gamslink.scr'
$if not setglobal oldfile $setglobal oldfile ''
$if '%oldfile%' == '%newfile%' $goto write_flat
$setglobal oldfile %newfile%
$if declared sslink_tmp $kill sslink_tmp
file sslink_tmp / %newfile% /;

$label write_flat
put sslink_tmp;
$setglobal timestamp no
$libinclude gams2txt %data%
$setglobal timestamp yes
putclose;

$set newcmdfile '%gams.scrdir%gamscmd.scr'
*.$set newcmdfile 'sslink.cmd'
$if not setglobal oldcmdfile $setglobal oldcmdfile ''
$if '%oldcmdfile%' == '%newcmdfile%' $goto cmdfileok
$setglobal oldcmdfile %newcmdfile%
$if declared sslink_cmd $kill sslink_cmd
file sslink_cmd / %newcmdfile% /;
$label cmdfileok
putclose sslink_cmd, '%newfile%'/'%ssfile%'/'%range%'/'-L';

execute 'echo SSDUMP %1 %2 %3  ';
execute 'echo SSDUMP %1 %2 %3 >>sslink.log';
if (execerror ne 0, execerror = 0);
execute '=%gams.sdir%sslink.exe $%newcmdfile%';
if (execerror ne 0,
  display "An SSLINK execution error occured following invocation:",
          "         SSDUMP %1 %2 %3",
          "See SSLINK.LOG for an error code.";
  execute 'echo === SSLINK command file:>>sslink.log';
  execute 'copy sslink.log+%newcmdfile% sslink.log >nul';
$if setglobal abortsserr  abort "Exiting GAMS program";
  display  "Continuing with GAMS program.";
  execerror = 0;
);

*.execute 'del %newcmdfile%';
