$if not setglobal debug $offlisting offinclude
$ontext

     SSEXPORT: A GAMS to Spreadsheet Ordered Data Export Utility

                     (an interface to SSLINK.EXE)

Usage:

     $LIBINCLUDE SSEXPORT ident[.suffix] ssfile range [-M]

          N.B.  Data transfer takes place at execution time.

$offtext

$if setglobal ss_system $goto countargs
$setglobal ss_system 'operating'
$echo %system.gstring%     >sslink.log
$echo SSLINK Activity Log >>sslink.log
$label countargs

$hidden         Begin by checking that the parameter exists:

$if a%5 == a  $goto startcheck
$error SSEXPORT extra argument = %5
$log *** SSEXPORT incorrect call
$exit

$label startcheck
$if not a%3 == a  $goto checkfile
$error SSEXPORT arguments missing data=%1 ssfile=%2 range=%3 options=%4
$log *** SSEXPORT incorrect call
$exit

$label checkfile
$if exist %2  $goto checkdata
$error SSEXPORT file missing = %2
$log *** SSEXPORT missing spreadsheet file
$exit

$label checkdata
$if declared %1 $goto declared
$error SSEXPORT data item no found = %1
$log *** SSEXPORT data item not found
$exit

$label declared
$if declared %1 $goto defined
$error SSEXPORT data item not defined = %1
$log *** SSEXPORT data item not defined
$exit

$label defined
$if not a%3 == %3 $goto checkopt
$error SSEXPORT spreadsheet range not specified
$log *** SSEXPORT spreadsheet range not specified -- use SSDUMP
$abort 

$label checkopt
$if  a%4 == a  $goto start
$if  %4 == -M  $goto start
$if  %4 == -m  $goto start
$if  %4 == M  $goto start
$if  %4 == m  $goto start
$error SSEXPORT invalid option %4.  The only recognized option is -M 
$log *** SSEXPORT invalid option %4.  The only recognized option is -M 
$abort 

$label start
$setlocal data   '%1'
$setlocal ssfile '%2'
$setlocal range  '%3'
$setlocal opts   '%4'

$log --- Exporting data "%data%" to "%ssfile%" into range "%range%"

$set newfile '%gams.scrdir%gamslink.scr'
$if not setglobal oldfile $setglobal oldfile ''
$if '%oldfile%' == '%newfile%' $goto fileok
$setglobal oldfile %newfile%
$if declared sslink_tmp $kill sslink_tmp
file sslink_tmp / %newfile% /;

$label fileok
$if not declared sslink_tmp file sslink_tmp / %newfile% /;
put sslink_tmp;
$setglobal timestamp no
$libinclude gams2txt %data%
$setglobal timestamp yes
putclose;

*$set newcmdfile '%gams.scrdir%gamscmd.scr'
$set newcmdfile 'sslink.cmd'
$if not setglobal oldcmdfile $setglobal oldcmdfile ''
$if '%oldcmdfile%' == '%newcmdfile%' $goto cmdfileok
$setglobal oldcmdfile %newcmdfile%
$if declared sslink_cmd $kill sslink_cmd
file sslink_cmd / %newcmdfile% /;
$label cmdfileok
putclose sslink_cmd, '%newfile%'/'%ssfile%'/'%range%'/'%opts%';

execute 'echo  SSEXPORT %1 %2 %3 %4';
execute 'echo  SSEXPORT %1 %2 %3 %4 >>sslink.log';
if (execerror ne 0, execerror = 0);
execute '=%gams.sdir%sslink.exe $%newcmdfile%';
if (execerror ne 0,
  display "An SSLINK execution error occured following invocation:",
          "         SSEXPORT %1 %2 %3 %4",
          "See SSLINK.LOG for an error code.";
  execute 'echo === SSLINK command file:>>sslink.log';
  execute 'copy sslink.log+%newcmdfile% sslink.log >nul';
$if setglobal abortsserr  abort "Exiting GAMS program";
  display  "Continuing with GAMS program.";
  execerror = 0;
);
execute 'del %newcmdfile%';

