$if not setglobal debug $offlisting offinclude

*       GAMS Scenario Interface Libinclude Routine -- writesol.gms
*       Thomas F. Rutherford
*       December, 2000

*	This program program writes a solution file.  Invocation:

*	$libinclude writesol item1 item2 item3 ... itemn

*	Nothing is done if the current scenario is undefined:

$if not setglobal scenario $exit

*	Create a subdirectory to hold solution files and the
*	symbol list:

$call 'if not exist output\nul mkdir output'
$call 'if exist output\items del  /q output\items\*.*'
$call 'if not exist output\items mkdir output\items'

*	Open the solution file for this scenario:

$if not defined solfile file solfile /'output\%scenario%.sol'/;  put solfile;

*	Place plot data (domain, labels, series and xvalue) at top of the file:

$if setglobal domain put '$setglobal domain %domain%'/;
$if setglobal labels put '$setglobal labels %labels%'/;
$if setglobal series put '$setglobal series %series%'/;
$if setglobal xvalue put '$setglobal xvalue %xvalue%'/;

$if not setglobal domain $goto labels
put '$if defined %domain% $goto %domain%'/;
$libinclude gams2prm %domain%
put '$label %domain%'/;

$label labels
$if not setglobal labels $goto series
put '$if defined %labels% $goto %labels%'/;
$libinclude gams2prm %labels%
put '$label %labels%'/;

$label series
$if not setglobal series $goto xvalue
put '$if defined %series% $goto %series%'/;
$libinclude gams2prm %series%
put '$label %series%'/;

$label xvalue
$if not setglobal xvalue $goto initexit
put '$if defined %xvalue% $goto %xvalue%'/;
$libinclude gams2prm %xvalue%
put '$label %xvalue%'/;

$label initexit
put '$if "%','1"=="" $exit'/;

*	Return here for each item in the list:

$label another

$if "%1"=="" $goto end

*	Generate a list of items for use by the PLOT and TABLE files:

$echo	defined	>output\items\%1

*	Insert a jump statement to skip over the item:

put '$if not %','1==%1 $goto %1'/;

*	Only accept parameters:

$if partype %1 $goto parameter
$error	Invalid argument to writesol -- arguments must be one-dimensional PARAMETER.
$stop

$label parameter
$setglobal prefix "'%scenario%.'"
$if dimension 1 %1 $goto put

$error	Parameter argument to writesol must be one-dimensional: %1
$stop

$label put
put '$setglobal title "',%1.ts,'"'/;
$libinclude gams2txt %1
put '$exit'/;
put '$label %1'/;

$label shift
$shift
$goto another

$label end
put	'$error	Solution item not found: %','1'
put	'$log 	Error -- solution item not found: %','1'
put	'$stop'/;
